<?php if (!defined('PmWiki')) exit();
/*
    wpcategories script, version 1.05
    Copyright 2009-2014 John Rankin (john.rankin@affinity.co.nz)
    works with PmWiki 2.2.56 or above
    requires php 5.3 or above and is compatible with php 5.5
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    
*/

SDV($CategoryGroup, 'Category');

if ($format=='pdf') {
    if ($ptype=='book') {
    
      $EnableBookIndex = true;

      ## '''[[!Category]]'''
      function wpcatHelper($m) {
        return '[['.strlen($m[1]).$m[2].']]');
      }
      Markup("''+!", "<'''''", "/(''+)\\[\\[(![^\\]]*?)\\]\\]\\1/", "wpcatHelper");

      ## [[!Category]]
      $LinkCategoryFmt = array('ix' => "<tbook:ix>\$LinkParent\$LinkText</tbook:ix>",
                              'ix2' => "<tbook:ix2>\$LinkText</tbook:ix2>",
                              'ixs' => "<tbook:ix sortkey='\$LinkSort'>\$LinkText</tbook:ix>",
                             'ix2s' => "<tbook:ix2 sortkey='\$LinkSort'>\$LinkText</tbook:ix2>");
      function wpcatentryHelper($m) {
        global $LinkCategoryFmt, $CategoryGroup;
        return '<s>'.Keep(MakeIndexEntry(NULL,$m[3],$m[2],$LinkCategoryFmt,$CategoryGroup),'L').$m[1];
      }
      Markup('[[!', '<[[', "/(\\s*)\\[\\[(\\d)?!(.*?)\\]\\]/", "wpcatentryHelper");

      ## [[!Category | text]]
      function wpcatlinkHelper($m) {
        global $LinkCategoryFmt, $CategoryGroup;
        return '<s>'.Keep(MakeIndexLink($CategoryGroup,$m[4],$m[5],$m[3],$m[2],$LinkCategoryFmt),'L').$m[1];
      }
      Markup('[[!|', '<[[!', "/(?>(\\s*)\\[\\[(\\d)?!([^|\\]]*)\\s*\\|\\s*)(!!?)?(.*?)\\s*\\]\\]/",
          "wpcatlinkHelper");

      ## '''[[$CategoryGroup/Category]]'''
      Markup("''+cat", "<'''''", "/(''+)\\[\\[($CategoryGroup\\/[^\\]]*?)\\]\\]\\1/",
          "wpcatHelper");

      ## [[$CategoryGroup/Category]]
      $LinkShowCategoryFmt = array('ix' => "<tbook:idx>\$LinkText</tbook:idx>",
                                  'ix2' => "",
                                  'ixs' => "<tbook:idx sortkey='\$LinkSort'>\$LinkText</tbook:idx>",
                                 'ix2s' => "");
      function wpcatshowHelper($m) {
        global $LinkShowCategoryFmt;
        return Keep(MakeIndexEntry($m[3],$m[2],$m[1],$LinkShowCategoryFmt),'L');
      }
      Markup('[[cat', '<[[', "/\\[\\[(\\d)?$CategoryGroup\\/([^|()\\]]+)(?:\\s*\\|\\s*(.*?)\\s*)?\\]\\]/",
          "wpcatshowHelper");


function MakeIndexLink($tgrp,$see=NULL,$txt,$cat,$kind=NULL,$fmtarray=NULL) {
  $ixsee = 'tbook:indexsee'; 
  return ($see) ? "<$ixsee".((strlen($see)>1) ? " also='true'>" : ">").
                             MakeIndexEntry('',$txt,'',$fmtarray,$tgrp).
                             MakeIndexEntry('',$cat,'',$fmtarray,$tgrp)."</$ixsee>" 
                : MakeIndexEntry($txt,$cat,$kind,$fmtarray,$tgrp);
}
function MakeIndexEntry($txt=NULL,$cat=NULL,$kind=NULL,$fmtarray=NULL,$tgrp=NULL) {
  global $IndexStart;
  if (preg_match('/\\((.*?)\\)/', $cat, $p)) {
      $parent = trim($p[1]); $cat = str_replace($p[0], '', $cat);
      $ppage  = MakePageName("$tgrp.$tgrp",$parent);
      if (PageExists($ppage)) $ptitle = 
         (PageVar($ppage, '$Title')==PageVar($ppage, '$Name')) ? '' : PageVar($ppage, '$Title');
      else $ptitle = '';
  } else
      $parent = '';
  $cat = trim($cat);
  $fmt = ($parent) ? $fmtarray['ix'] : ($txt ? $fmtarray['ixs'] : $fmtarray['ix']);
  if ($ptitle) {
      $fmt = str_replace('>$', ' sortkey="'.$parent.'">$', $fmt);
      $parent = $ptitle;
  }
  if ($kind) {
      $k = $kind-2;
      if (@$IndexStart[$cat]) { 
          $k = 2; $IndexStart[$cat] = false;
      } elseif ($k>2) { 
          $k = 3; $IndexStart[$cat] = true; 
      }
      $attr = array('italic', 'bold', 'end', 'start');
      $fmt  = str_replace('>$', ' kind="'.$attr[$k].'">$', $fmt);
  }
  $text = ($txt) ? $fmtarray['ix2s'] : $fmtarray['ix2'];
  $fmt  = str_replace('$LinkParent', $parent, ($parent ? str_replace('$LinkText', $text, $fmt) : $fmt));
  return ($txt) ? str_replace(array('$LinkSort','$LinkText'), array($cat,$txt), $fmt) : 
                  str_replace('$LinkText', $cat, $fmt);
}

    } else {

      ## '''[[!Category]]'''
      function wpcatemHelper($m) {
        return '<tbook:mnote class="mnote">'.$m[1].MarginCategory($m[2]).$m[1].
               '</tbook:mnote>';
      }
      function wpcatnoteHelper($m) {
        return '<tbook:mnote class="mnote">'.MarginCategory($m[1]).
               '</tbook:mnote>';
      }
      Markup("''+!", "<'''''", "/(''+)\\[\\[!([^\\]]*?)\\]\\]\\1/", 
        "wpcatemHelper");
      Markup("cat!", ">'''''", "/\\[\\[!([^\\]]*?)\\]\\]/",
        "wpcatnoteHelper");

      ## '''[[$CategoryGroup/Category]]'''
      function wpcatvemHelper($m) {
        return $m[0].wpcatemHelper($m);
      }
      function wpcatvnoteHelper($m) {
        return $m[0].wpcatnoteHelper($m);
      }
      Markup("''+cat", "<'''''", "/(''+)\\[\\[$CategoryGroup\\/([^\\]]*?)\\]\\]\\1/", 
        "wpcatvemHelper");
      Markup("cat/", ">'''''", "/\\[\\[$CategoryGroup\\/([^\\]]*?)\\]\\]/", 
        "wpcatvnoteHelper");
      
      function MarginCategory($cat) {
        if (preg_match('/^([^|]+)\\s*\\|\\s*(!!?)?(.*?)$/', $cat, $c)) {
            $s = str_repeat(':',strlen($c[2])) . ' ';
            return $c[2] ? IndexSubindex($c[3],$c[3]).$s.IndexSubindex($c[1],$c[1]) : $c[3];
        } else
            return IndexSubindex($cat, $cat);
      }

    }
} else {

  ## [[!Category |Text]]
  Markup_e('[[!','<[[|',"/\\[\\[(?:!|$CategoryGroup\\/)([^|\\]]+)(?:\\s*\\|\\s*(!!?)?(.*?)\\s*)?\\]\\]/",
  "Keep(MakeLink(\$pagename,
                 '$CategoryGroup/'.\$m[1],
                 (\$m[3] ? IndexSeeCheck(\$m[2],\$m[3]) : IndexSubindex(\$m[1])),
                 '',
                 \$GLOBALS['LinkCategoryFmt']),'L')");
  function IndexSeeCheck($see=NULL, $cat) {
    return $see ? IndexSubindex($cat, $cat) : $cat;
  }
}
function IndexSubindex($cat, $r=NULL) {
  if (preg_match('/\\((.*?)\\)/', $cat, $p)) $r = trim($p[1]).', '.str_replace($p[0], '', $cat);
  return $r;
}
function ValidateIndexRanges($pagename) {
  global $IndexStart;
  $o[] = "<p>Fix range(s):</p><itemize>";
  foreach((array)$IndexStart as $k => $v)
    if ($v) $o[] = "<item>$k</item>";
  echo (count($o)>1) ? implode("\n",$o)."</itemize>" : '';
}

?>
